//*****************************************
// Photo Box with ATmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
////
//@OLED 128x64 Control IC: SSD1306
//    H@nkdc\ihhbj
//
//@RTC RX8900(EPSON)
//
// File Name:disp_clock_data.c
//
//  PC5(SCL): TWI-SCL
//  PC4(SDA): TWI-SDA
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2023/05/14 New  for mega328_iic_oled_rtc Taishi (TAB4)
//  2023/12/09 Modify for Photo Box with ATmega2560 Taishi
//*****************************************

#include	"pr_mega2560_photo_box_h.h"

#include	"timer_h.h"
#include	"mega_Twi_h.h"
#include	"port_bit_h.h"
#include	"oled_1306_h.h"
#include	"Rtc_Rx8900_h.h"
#include	"ad_conv_h.h"
#include	"disp_8x48_dot_h.h"

#include	"disp_clock_data_h.h"

enum DISP_FUNC_ITEM {		// \֐
		F_6x8 = 0,			// UW\
		F_12x16,			// PQPU\
		F_18x24,			// PWQS\
		F_24x32,			// QSRQ\

		F_END
	};

struct DISP_ITEM {
	unsigned char di_clock;		//\镨
	unsigned char di_fsize;		//\tHgTCY
	unsigned char di_x;			//\ʒuw
	unsigned char di_y;			//\ʒux
	unsigned char *di_bcd;		//\f[^

};

struct DISP_CONST {
	unsigned char dc_fsize;		//\tHgTCY
	unsigned char dc_x;			//\ʒuw
	unsigned char dc_y;			//\ʒux
	         char *dc_pdt;		//

};

unsigned char	gAd0_ave_h;
unsigned char	gAd0_ave_l;

// ----- ɃO[o̎vf[^iabcj -----
// ----- ɏB܂ł               -----
#if	0
unsigned char	gYear = 0x22;
unsigned char	gMon  = 0x12;
unsigned char	gDay  = 0x31;
unsigned char	gHou  = 0x23;
unsigned char	gMin  = 0x58;
unsigned char	gSec  = 0x00;

void	inc_tokei_data_kari(void)
{
	unsigned char	day_max;


	gSec++;
	if(0x09 < (gSec & 0x0f)){
		gSec &= 0xf0;
		gSec += 0x10;
		if(0x59 < gSec){
			gSec = 0;
			gMin++;
			if(0x09 < (gMin & 0x0f)){
				gMin &= 0xf0;
				gMin += 0x10;
				if(0x59 < gMin){
					gMin = 0;
					gHou++;
					if(0x09 < (gHou & 0x0f)){
						gHou &= 0xf0;
						gHou += 0x10;
					}
					if(0x23 < gHou){
						gHou = 0;
						gDay++;
						day_max = 0x31;
						if((gMon == 4)||(gMon == 6)||(gMon == 9)||(gMon == 0x11)){	// ̌
							day_max = 0x30;
						}else if(gMon == 2){
							day_max = 0x28;
							if(((((gYear>>4)*10) + (gYear&0x0f))  % 4) == 0){		// 邤N
								day_max = 0x29;
							}
						}
						if(0x09 < (gDay & 0x0f)){
							gDay &= 0xf0;
							gDay += 0x10;
						}
						if(day_max < gDay){
							gDay = 1;
							gMon++;
							if(0x09 < (gMon & 0x0f)){
								gMon &= 0xf0;
								gMon += 0x10;
							}
							if(0x12 < gMon){
								gMon = 1;
								gYear++;
								if(0x09 < (gYear & 0x0f)){
									gYear &= 0xf0;
									gYear += 0x10;
								}
								if(0x99 < gYear){
									gYear = 0;
								}
							}
						}
					}
				}
			}
		}
	}
}
#endif

// --------------------------------------------------

static
struct DISP_ITEM	gDisp_block_item[D_END+1]={
	{D_YEAR, 		F_12x16,  4*6, 0*8, (unsigned char *)&gRTC_year},		// Year
	{D_MON,  		F_12x16, 11*6, 0*8, (unsigned char *)&gRTC_mon},		// Month
	{D_DAY,  		F_12x16, 17*6, 0*8, (unsigned char *)&gRTC_day},		// Day
	{D_HOUR, 		F_24x32,  0*6, 2*8, (unsigned char *)&gRTC_hou},		// Hour
	{D_MIN,  		F_24x32, 13*6, 2*8, (unsigned char *)&gRTC_min},		// Min
	{D_SEC,  		F_12x16, 17*6, 6*8, (unsigned char *)&gRTC_sec},		// Sec
	{D_TEMPE,		F_12x16,  1*6, 6*8, (unsigned char *)&gRTC_tempe},		// Tempe
	{D_BRIGHT_H,	F_12x16, 10*6, 6*8, (unsigned char *)&gAd0_ave_h},		// Brightness High
	{D_BRIGHT_L,	F_12x16, 12*6, 6*8, (unsigned char *)&gAd0_ave_l},		// Brightness Low

	{D_END,    F_END,    0,   0, (unsigned char *)&gRTC_sec},			// I
};

char	do_see[3]={0xdf,0x43,0};
static
struct DISP_CONST	gDisp_block_const[]={
	{F_12x16,   0*6, 0*8, "20"},			// '20'
	{F_12x16,  15*6, 0*8,  "/"},			// '/'
	{F_24x32, 8*6+3, 2*8,  ":"},			// ':'
	{F_12x16,   5*6, 6*8,  do_see},			// ''

	{  F_END,     0,   0,   ""},			// I
};

static
struct DISP_CONST	gDisp_block_title[]={
	{F_18x24,   3*6, 0*8, "CLOCK"},
	{F_12x16,   2*6, 4*8, "by RX8900"},
//	{F_12x16,   5*6, 6*8,  "V1.00"},
	{F_12x16,   5*6, 6*8,  Ver_Str},

	{  F_END,     0,   0,   ""},			// I
};

//***************************
// xlɌvZ
// qqwWXOÔ D̒lioCi[j
//   abc̉xlɂBij
//   f[^V[ǧvZPOO{ɂ vZɂ
//    (TEMP * 2 - 187.19)/3.218 Ȃ̂
//  ond = ((TEMP Reg * 200) - 18719)/322 ɂ
//  QoCǧvZłӂ͂ȂB
//  XXx𒴂鎖͓쉷x炠肦ȂB
//  }CiXɂȂ鎖͂肦邪A̎͂Oxɂ
//***************************
unsigned char	calcu_tempe(unsigned char uc)
{
	unsigned short	us;
	unsigned char	r;

	us = uc;
	us *= 200;
	if(us <= 18719){				// }CiXɂȂ鎞
		us = 0;
	}else{							// vX̎
		us -= 18719;
		us /= 322;
	}

	r  = ((us % 100) / 10) * 0x10;	// PǑ
	r += (us % 10);					// P̌

	return(r);
}

//***************************
// Qabcf[^imax 0xff)AXL[Qɂ
//***************************
void	set_hex_2(unsigned char *bf, unsigned char uc)
{
	unsigned char	nh;
	unsigned char	nl;

	nh = uc;
	nh >>= 4;
	nl = uc;
	nl &= 0x0f;

	if((0 <= nh) && ( nh <= 9)){			// lȎ
		*(bf+0) = (nh + '0');
	}else{
		*(bf+0) = (nh-10 + 'A');
	}

	if((0 <= nl) && ( nl <= 9)){			// lȎ
		*(bf+1) = (nl + '0');
	}else{
		*(bf+1) = (nl-10 + 'A');
	}

	*(bf+2) = 0x00;

}

//***************************
// Rgdwf[^imax 0xfff)AXL[Rɂ
//***************************
void	set_hex_3(unsigned char *bf, unsigned short us)
{
	unsigned char	nh;
	unsigned char	nm;
	unsigned char	nl;

	us &= 0xfff;
	nh = (us >> 8);
	nm = ((us >> 4) & 0x0f);
	nl = (us & 0x0f);

	if((0 <= nh) && ( nh <= 9)){			// OX̎
		*(bf+0) = (nh + '0');
	}else{
		*(bf+0) = (nh-10 + 'A');			// POPT̎
	}

	if((0 <= nm) && ( nm <= 9)){			// OX̎
		*(bf+1) = (nm + '0');
	}else{
		*(bf+1) = (nm-10 + 'A');			// POPT̎
	}

	if((0 <= nl) && ( nl <= 9)){			// OX̎
		*(bf+2) = (nl + '0');
	}else{
		*(bf+2) = (nl-10 + 'A');			// POPT̎
	}

	*(bf+3) = 0x00;

}
//*****************************************
// Ԗڂ߂
//*****************************************
static
unsigned char	get_disp_block_num(unsigned char inum)
{
	unsigned char	uc;

	for(uc = 0; ; uc++){
		if(gDisp_block_item[uc].di_clock == inum){
			break;
		}else if(gDisp_block_item[uc].di_clock == D_END){
			break;
		}else if(gDisp_block_item[uc].di_fsize == F_END){
			break;
		}
	}

	return(uc);
}

//*****************************************
// vf[^̕\
//  Pڂ̕\
//  item_num : \镨̎
//      disp : 1=\A 0=iXy[X\j
//*****************************************
void	disp_clock_item(unsigned char item_num, unsigned char disp)
{
	unsigned char		bn;
	unsigned char		ucbf[3]={' ',' ',0};
	unsigned char		pos_x;					// hbgPʂ̂wʒu
	unsigned char		pos_y;					// hbgPʂ̂xʒu
	unsigned char		uc;						// f[^
	unsigned char		u_func;					// gp֐

	bn = get_disp_block_num(item_num);			// Ԗڂ߂
	u_func = gDisp_block_item[bn].di_fsize;		// gp֐̎
	pos_x = gDisp_block_item[bn].di_x;			// pos_x
	pos_y = gDisp_block_item[bn].di_y;			// pos_y
	uc = *(gDisp_block_item[bn].di_bcd);		// data

	if(disp == 1){
		if(item_num == D_TEMPE){				// TEMP Reg. ̃f[^̎
			uc = calcu_tempe(uc);				// xlɌvZ
		}
		set_hex_2(&(ucbf[0]), uc);				// abcimax 0x99)AXL[Qɂ
	}
	if(u_func == F_24x32){
		disp_oled_G_24x32(pos_x, pos_y, ucbf);	// x, y, BCD data(24x32)
	}else if(u_func == F_18x24){
		disp_oled_G_18x24(pos_x, pos_y, ucbf);	// x, y, BCD data(18x24)
	}else if(u_func == F_12x16){
		disp_oled_G_12x16(pos_x, pos_y, ucbf);	// x, y, BCD data(12x16)
	}else{
		disp_oled_G(pos_x, pos_y, ucbf);		// x, y, BCD data(6x8)
	}
}

//*****************************************
// v̌Œ\
//*****************************************
void	disp_clock_const(void)
{
	unsigned char		bn;
	unsigned char		*pbf;
	unsigned char		pos_x;				// hbgPʂ̂wʒu
	unsigned char		pos_y;				// hbgPʂ̂xʒu
	unsigned char		u_func;				// gp֐

	for(bn = 0;  ;bn++){
		if(gDisp_block_const[bn].dc_fsize == F_END){	// tHgTCY eQdlc͕̎\ȂŏI
			break;
		}

		u_func = gDisp_block_const[bn].dc_fsize;	// gp֐̎
		pos_x = gDisp_block_const[bn].dc_x;			// pos_x
		pos_y = gDisp_block_const[bn].dc_y;			// pos_y
		pbf = (unsigned char *)(gDisp_block_const[bn].dc_pdt);			// \

		if(u_func == F_24x32){
			disp_oled_G_24x32(pos_x, pos_y, pbf);	// x, y, data (24x32)
		}else if(u_func == F_18x24){
			disp_oled_G_18x24(pos_x, pos_y, pbf);	// x, y, data(18x24)
		}else if(u_func == F_12x16){
			disp_oled_G_12x16(pos_x, pos_y, pbf);	// x, y, data(12x16)
		}else{
			disp_oled_G(pos_x, pos_y, pbf);			// x, y, data(6x8)
		}
	}
}

//*****************************************
// ^CǧŒ\
//*****************************************
void	disp_clock_title(void)
{
	unsigned char		bn;
	unsigned char		*pbf;
	unsigned char		pos_x;				// hbgPʂ̂wʒu
	unsigned char		pos_y;				// hbgPʂ̂xʒu
	unsigned char		u_func;				// gp֐

	for(bn = 0;  ;bn++){
		if(gDisp_block_title[bn].dc_fsize == F_END){	// tHgTCY eQdlc͕̎\ȂŏI
			break;
		}

		u_func = gDisp_block_title[bn].dc_fsize;	// gp֐̎
		pos_x = gDisp_block_title[bn].dc_x;			// pos_x
		pos_y = gDisp_block_title[bn].dc_y;			// pos_y
		pbf = (unsigned char *)(gDisp_block_title[bn].dc_pdt);			// \

		if(u_func == F_24x32){
			disp_oled_G_24x32(pos_x, pos_y, pbf);	// x, y, data(24x32)
		}else if(u_func == F_18x24){
			disp_oled_G_18x24(pos_x, pos_y, pbf);	// x, y, (18x24)
		}else if(u_func == F_12x16){
			disp_oled_G_12x16(pos_x, pos_y, pbf);	// x, y, data(12x16)
		}else{
			disp_oled_G(pos_x, pos_y, pbf);			// x, y, data(6x8)
		}
	}
}

//*****************************************
// vf[^̕\
//  init : 1=Sĕ\A 0=ω̕\
//*****************************************
void	disp_clock_data(unsigned char init)
{
	static	unsigned char	old_year = 0xff;
	static	unsigned char	old_mon  = 0xff;
	static	unsigned char	old_day  = 0xff;
	static	unsigned char	old_hou  = 0xff;
	static	unsigned char	old_min  = 0xff;
	static	unsigned char	old_sec  = 0xff;
	static	unsigned char	old_tempe  = 0xff;
	static	int				old_ad   = 0xffff;

	if(init == 1){
		old_year = 0xff;
		old_mon  = 0xff;
		old_day  = 0xff;
		old_hou  = 0xff;
		old_min  = 0xff;
		old_sec  = 0xff;
		old_tempe  = gRTC_tempe+1;
		old_ad   = 0xffff;
	}

	if(old_year != gRTC_year){				// Nω
		old_year = gRTC_year;
		disp_clock_item(D_YEAR,1);			// N\
		disp_8x48_clock_item(I_YEAR,1);		// 8x48 N\
		disp_8x48_clock_item(I_WD,1);		// 8x48_j\
	}
	if(old_mon != gRTC_mon){				// ω
		old_mon = gRTC_mon;
		disp_clock_item(D_MON,1);			// \
		disp_8x48_clock_item(I_MON,1);		// 8x48_\
		disp_8x48_clock_item(I_WD,1);		// 8x48_j\
	}
	if(old_day != gRTC_day){				// ω
		old_day = gRTC_day;
		disp_clock_item(D_DAY,1);			// \
		disp_8x48_clock_item(I_DAY,1);		// 8x48_\
		disp_8x48_clock_item(I_WD,1);		// 8x48_j\
	}
	if(old_hou != gRTC_hou){				// ω
		old_hou = gRTC_hou;
		disp_clock_item(D_HOUR,1);			// \
		disp_8x48_clock_item(I_HOUR,1);		// 8x48_\
	}
	if(old_min != gRTC_min){				// ω
		old_min = gRTC_min;
		disp_clock_item(D_MIN,1);			// \
		disp_8x48_clock_item(I_MIN,1);		// 8x48_\
	}
	if(old_sec != gRTC_sec){				// bω
		old_sec = gRTC_sec;
		disp_clock_item(D_SEC,1);			// b\
		disp_8x48_clock_item(I_SEC,1);		// 8x48_b\
	}
	if(old_tempe != gRTC_tempe){			// xω
		old_tempe = gRTC_tempe;
		disp_clock_item(D_TEMPE,1);			// x\
		disp_8x48_clock_item(I_TEMPE,1);	// 8x48_x\
	}
	if(old_ad != gAd0_ave){					// `^ci邳jω
		old_ad = gAd0_ave;
		gAd0_ave_h = ((gAd0_ave >> 4)&0xff);
		disp_clock_item(D_BRIGHT_H,1);		// 邳\iʁj
		gAd0_ave_l = (gAd0_ave & 0xff);
		disp_clock_item(D_BRIGHT_L,1);		// 邳\iʁj
		disp_8x48_clock_item(I_BRIGHT,1);	// 8x48_邳\
	}
}

