//*****************************************
// Photo Box with ATmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
//@OLED 128x64 Control IC: SSD1306
//    ĤPQWUŜnkdc\ihhbj
//
// File Name:oled_1306.c
//
//@ȉnkdcɕKvȐMꗗ
//
//  PC5(SCL): TWI-SCL
//  PC4(SDA): TWI-SDA
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2014/03/28 New
//  2014/12/21 modify for ATMEGA328
//  2023/03/07 Modify for mega328_i2c_old Taishi
//  2023/05/13 Modify for mega328_iic_oled_rtc Taishi
//  2023/12/09 Modify for Photo Box with ATmega2560 Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>

#include	"pr_mega2560_photo_box_h.h"

#include	"timer_h.h"
#include	"Pfont5x7_h.h"
#include	"Mega_twi_h.h"
#include	"OLED_1306_h.h"

//#define		UPSIDE_DOWN				// |iSoRlN^j̎BiSoRlN^j̎̓RgAEg

unsigned char	disp_moji[43];												// nkdc\

// ************************************* Graphic OLED Accese *********************
static	unsigned char	c_data[4][24];
static	unsigned char	c_data0[10];


//******************************
// Get Character Bit Data
// 5x7 Font
//  Get Data Save to c_data0[5];
//******************************
static void	get_asc_data(unsigned char uc)
{
	unsigned short	us;

	us = uc;

	c_data0[0] = pgm_read_byte(&(font5x7[us * 5 + 0]));
	c_data0[1] = pgm_read_byte(&(font5x7[us * 5 + 1]));
	c_data0[2] = pgm_read_byte(&(font5x7[us * 5 + 2]));
	c_data0[3] = pgm_read_byte(&(font5x7[us * 5 + 3]));
	c_data0[4] = pgm_read_byte(&(font5x7[us * 5 + 4]));
}


//******************************
// Init. OLED
//
// *****************************
void	init_oled_G(void)
{
	twi_init();			// TWI ݒ

	delay_ms(100);

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

	twi_write(0xAE);	// Display OFF

	twi_write(0xD5);	// Set Display Clock Divide Ratio / Oscillator Frequency
	twi_write(0x80);	//  Default => 0x80  D[3:0] => Display Clock Divider, D[7:4] => Oscillator Frequency

	twi_write(0xA8);	// Set Multiplex Ratio
	twi_write(0x3F);	//   Default => 0x3F (1/64 Duty)

	twi_write(0xD3);	// Set Display Offset
	twi_write(0x00);	//   Default => 0x00

	twi_write(0x40 | 0x00);	// Set Display Start Line  Default => 0x40 (0x00)

	twi_write(0x8D);	// Set Charge Pump
	twi_write(0x14);	//   Default => 0x10   0x10 => Disable Charge Pump, 0x14 => Enable Charge Pump

	twi_write(0x20);	// Set Memory Addressing Mode
	twi_write(0x02);	//   Default => 0x02   0x00 => Horizontal Addressing Mode,  0x01 => Vertical Addressing Mode,  0x02 => Page Addressing Mode

#ifdef	UPSIDE_DOWN
	twi_write(0xA0);	// Set Segment Re-Map  Default => 0xA0   0xA0 => Column Address 0 Mapped to SEG0,  0xA1 => Column Address 0 Mapped to SEG127
	twi_write(0xC0);	// Set COM Output Scan Direction  Default => 0xC0   0xC0 => Scan from COM0 to 63,  0xC8 => Scan from COM63 to 0
#else
	twi_write(0xA1);	// Set Segment Re-Map  Default => 0xA0   0xA0 => Column Address 0 Mapped to SEG0,  0xA1 => Column Address 0 Mapped to SEG127
	twi_write(0xC8);	// Set COM Output Scan Direction  Default => 0xC0   0xC0 => Scan from COM0 to 63,  0xC8 => Scan from COM63 to 0
#endif

	twi_write(0xDA);	// Set COM Pins Hardware Configuration
	twi_write(0x12);	//   Default => 0x12   Alternative COM Pin Configuration  Disable COM Left/Right Re-Map

	twi_write(0x81);	// Set Contrast Control
	twi_write(0xFF);	//   Default => 0x7F

	twi_write(0xD9);	// Set Pre-Charge Period
	twi_write(0x22);	// Default => 0x22 (2 Display Clocks [Phase 2] / 2 Display Clocks [Phase 1])  D[3:0] => Phase 1 Period in 1~15 Display Clocks, D[7:4] => Phase 2 Period in 1~15 Display Clocks

	twi_write(0xDB);	// Set VCOMH Deselect Level
	twi_write(0x40);	//   Default => 0x20 (0.77*VCC)

	twi_write(0xA4);	// Set Entire Display On / Off  Default => 0xA4  0xA4 => Normal Display,  0xA5 => Entire Display On

	twi_write(0xA6);	// Set Inverse Display On/Off   Default => 0xA6   0xA6 => Normal Display,  0xA7 => Inverse Display On

	twi_stop();			// TWI ~

	disp_clear_oled_G();	// Clear All Display

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_CMD_MONO);		// R}h

	twi_write(0xAF);	// Display ON

	twi_stop();			// TWI ~

}
//******************************
// Clear All Display
// *****************************
void	disp_clear_oled_G(void)
{

	unsigned char	x;
	unsigned char	y;

	for(y=0;y < 8;y++){
		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

		twi_write((0xb0 | y));					// Page Set

		twi_write(0x10);						// Column High Address Set
		twi_write(0x00);						// Column Low Address Set

		twi_stop();								// TWI ~

		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐
		for(x=0;x <128; x++){
			twi_write(0x00);
		}
		twi_stop();								// TWI ~
	}

}
//******************************
// Clear All Display Reversei]\j
// *****************************
void	disp_clear_oled_G_reverse(void)
{

	unsigned char	x;
	unsigned char	y;

	for(y=0;y < 8;y++){
		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

		twi_write((0xb0 | y));					// Page Set

		twi_write(0x10);						// Column High Address Set
		twi_write(0x00);						// Column Low Address Set

		twi_stop();								// TWI ~

		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐
		for(x=0;x <128; x++){
			twi_write(0x00);
		}
		twi_stop();								// TWI ~
	}

}
//******************************
// One Line Clear Display
//   y: line number(0--63)
// *****************************
void	disp_line_clear_oled_G(unsigned char y)
{
	unsigned char	x;

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

	y %= 64;
	twi_write((0xb0 | (y/8)));					// Page Set

	twi_write(0x10);						// Column High Address Set
	twi_write(0x00);						// Column Low Address Set

	twi_stop();								// TWI ~

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐
	for(x=0;x <128; x++){
		twi_write(0x00);
	}
	twi_stop();								// TWI ~
}
//******************************
// One Line Clear Display i]\j
//   y: line number(0--63)
// *****************************
void	disp_line_clear_oled_G_reverse(unsigned char y)
{
	unsigned char	x;

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐


	y %= 64;
	twi_write((0xb0 | y/8));				// Page Set

	twi_write(0x10);						// Column High Address Set
	twi_write(0x00);						// Column Low Address Set

	twi_stop();								// TWI ~

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐
	for(x=0;x <128; x++){
		twi_write(0xff);
	}
	twi_stop();								// TWI ~
}
//******************************
// display OLED One charcter
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  uc : Charcter
//    E\sb`͂UhbgitHgԂPhbgLj
// *****************************
void	disp_one_char_oled_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	j;
	unsigned char	x;

	x = (pos_x % 128);
	pos_y %= 64;

	get_asc_data(uc);						// Get Character Bit Data

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

	twi_write((0xb0 | pos_y/8));			// Page Set

	twi_write(x & 0x0f);					// Column Low Address Set
	twi_write(0x10 | (x >> 4));				// Column High Address Set

	twi_stop();								// TWI ~


	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐

	c_data0[5] = 0x00;
	for(j = 0;((j<6)&&(x<128)); j++,x++){
		twi_write(c_data0[j]);
	}

	twi_stop();								// TWI ~

}
//******************************
// display OLED One charcteri]\j
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 83)
//  uc : Charcter
//    E\sb`͂UhbgitHgԂPhbgLj
// *****************************
void	disp_one_char_oled_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	j;
	unsigned char	x;

	x = (pos_x % 128);
	pos_y %= 64;

	get_asc_data(uc);						// Get Character Bit Data

	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

	twi_write((0xb0 | pos_y/8));			// Page Set

	twi_write(x & 0x0f);					// Column Low Address Set
	twi_write(0x10 | (x >> 4));				// Column High Address Set

	twi_stop();								// TWI ~


	twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
	twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐

	c_data0[5] = 0x00;
	for(j = 0;((j<6)&&(x<128)); j++,x++){
		twi_write(c_data0[j] ^ 0xff);
	}

	twi_stop();								// TWI ~

}
//******************************
// display OLED(20char x 8Line)
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_oled_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	j;
	unsigned char	x;

	x = (pos_x % 128);
	pos_y %= 64;

	while(*ucp != 0x00){						// String Data Out
		if(127 < x){
			break;
		}
		get_asc_data(*ucp);						// Get Character Bit Data

		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

		twi_write((0xb0 | pos_y/8));			// Page Set

		twi_write(x & 0x0f);					// Column Low Address Set
		twi_write(0x10 | (x >> 4));				// Column High Address Set

		twi_stop();								// TWI ~


		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐

		c_data0[5] = 0x00;
		for(j = 0;((j<6)&&(x<128)); j++,x++){
			twi_write(c_data0[j]);
		}

		twi_stop();								// TWI ~

		ucp++;
	}
}
//******************************
// display OLED(20char x 8Line, ]\)
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_oled_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	j;
	unsigned char	x;

	x = (pos_x % 128);
	pos_x %= 128;
	pos_y %= 64;

	while(*ucp != 0x00){						// String Data Out
		if(127 < x){
			break;
		}
		get_asc_data(*ucp);						// Get Character Bit Data

		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

		twi_write((0xb0 | pos_y/8));			// Page Set

		twi_write(x & 0x0f);					// Column Low Address Set
		twi_write(0x10 | (x >> 4));				// Column High Address Set

		twi_stop();								// TWI ~


		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐

		c_data0[5] = 0x00;
		for(j = 0;((j<6)&&(x<128)); j++,x++){
			twi_write(c_data0[j] ^ 0xff);
		}

		twi_stop();								// TWI ~

		ucp++;
	}
}

// TVtHgPOPUɊĝׂQhbg̃f[^
const	unsigned char bt_07_10x16[8][2]={						// 5x7  10x16 ɑ傫鎞Ɏg
									{0b00000011, 0b00000000},	// D0
									{0b00001100, 0b00000000},	// D1
									{0b00110000, 0b00000000},	// D2
									{0b11000000, 0b00000000},	// D3
									{0b00000000, 0b00000011},	// D4
									{0b00000000, 0b00001100},	// D5
									{0b00000000, 0b00110000},	// D6
									{0b00000000, 0b11000000},	// D7
								};
//******************************
// Get Character Bit Data
// 10x16 Font
//  Get Data Save to c_data[4][15];
//******************************
static void	get_asc_data_10x16(unsigned char uc)
{
	unsigned short	us;
	unsigned char	ucd;
	unsigned char	i;
	unsigned char	j;
	unsigned char	k;
	unsigned char	bt;

	us = uc;
	us *= 5;

	for(i=0;i<10;i++){										// tHg鏊NA
		for(j=0;j<2;j++){
			c_data[j][i] = 0;
		}
	}

	for(i=0;i<5;i++){										// 5x7 tHg擾郋[v
		ucd = pgm_read_byte(&(font5x7[us + i]));
		for(bt=0x01,k=0;k<8;k++, bt<<= 1){					// 擾Wrbg̃f[^郋[v
			if((ucd & bt)!=0){
				for(j=0;j<2;j++){							// 5x7 ̂Prbg̃f[^2x2 ̃f[^ɂ郋[vi͂PỎj
					c_data[0][i*2+j] |= bt_07_10x16[k][0];
					c_data[1][i*2+j] |= bt_07_10x16[k][1];
				}
			}
		}
	}

}
//******************************
// display OLED One charcter 12x16 Font
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 64)
//  uc : Charcter
//    E\sb`͂PQbgitHgԂQhbgLj
// *****************************
void	disp_one_char_oled_G_12x16(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	i;
	unsigned char	j;
	unsigned char	x;

	pos_x %= 128;
	pos_y %= 64;
	pos_y /= 8;

	get_asc_data_10x16(uc);						// Get Character Bit Data

	for(i=0;i<2;i++){
		if(7 < (pos_y + i)){
			break;
		}

		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

		twi_write(0xb0 | (pos_y+i));			// Page Set

		twi_write(pos_x & 0x0f);				// Column Low Address Set
		twi_write(0x10 | (pos_x >> 4));			// Column High Address Set

		twi_stop();								// TWI ~

		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐

		c_data[i][10] = 0x00;
		c_data[i][11] = 0x00;
		x = pos_x;
		for(j = 0;((j<12)&&(x<128)); j++,x++){
			twi_write(c_data[i][j]);
		}

		twi_stop();								// TWI ~

	}
}
//******************************
// display OLED 12x16 Font (10char x 4Line)
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_oled_G_12x16(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos_x %= 128;
	pos_y %= 64;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(127 < pos){
			break;
		}
		disp_one_char_oled_G_12x16(pos, pos_y, *ucp);
		ucp++;
		pos += 12;
	}
}


// TVtHgPTQSɊĝׂRhbg̃f[^
const	unsigned char bt_07_15x24[8][3]={											// 5x7  15x24 ɑ傫鎞Ɏg
									{0b00000111, 0b00000000, 0b00000000},	// D0
									{0b00111000, 0b00000000, 0b00000000},	// D1
									{0b11000000, 0b00000001, 0b00000000},	// D2
									{0b00000000, 0b00001110, 0b00000000},	// D3
									{0b00000000, 0b01110000, 0b00000000},	// D4
									{0b00000000, 0b10000000, 0b00000011},	// D5
									{0b00000000, 0b00000000, 0b00011100},	// D6
									{0b00000000, 0b00000000, 0b11100000},	// D7
								};
//******************************
// Get Character Bit Data
// 15x24 Font
//  Get Data Save to c_data[4][15];
//******************************
static void	get_asc_data_15x24(unsigned char uc)
{
	unsigned short	us;
	unsigned char	ucd;
	unsigned char	i;
	unsigned char	j;
	unsigned char	k;
	unsigned char	bt;

	us = uc;
	us *= 5;

	for(i=0;i<15;i++){										// tHg鏊NA
		for(j=0;j<3;j++){
			c_data[j][i] = 0;
		}
	}

	for(i=0;i<5;i++){										// 5x7 tHg擾郋[v
		ucd = pgm_read_byte(&(font5x7[us + i]));
		for(bt=0x01,k=0;k<8;k++, bt<<= 1){					// 擾Wrbg̃f[^郋[v
			if((ucd & bt)!=0){
				for(j=0;j<3;j++){							// 5x7 ̂Prbg̃f[^3x3 ̃f[^ɂ郋[vi͂PT̉j
					c_data[0][i*3+j] |= bt_07_15x24[k][0];
					c_data[1][i*3+j] |= bt_07_15x24[k][1];
					c_data[2][i*3+j] |= bt_07_15x24[k][2];
				}
			}
		}
	}

}
//******************************
// display OLED One charcter 18x24 Font
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  uc : Charcter
//    E\sb`͂PWhbgitHgԂRhbgLj
// *****************************
void	disp_one_char_oled_G_18x24(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	i;
	unsigned char	j;
	unsigned char	x;

	pos_x %= 128;
	pos_y %= 64;
	pos_y /= 8;

	get_asc_data_15x24(uc);						// Get Character Bit Data

	for(i=0;i<3;i++){
		if(7 < (pos_y + i)){
			break;
		}
		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

		twi_write(0xb0 | (pos_y+i));			// Page Set

		twi_write(0x10 | (pos_x >> 4));			// Column High Address Set
		twi_write(pos_x & 0x0f);				// Column Low Address Set

		twi_stop();								// TWI ~


		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐

		c_data[i][15] = 0x00;
		c_data[i][16] = 0x00;
		c_data[i][17] = 0x00;
		x = pos_x;
		for(j = 0;((j<18)&&(x<128)); j++,x++){
			twi_write(c_data[i][j]);
		}

		twi_stop();								// TWI ~

	}
}
//******************************
// display OLED 18x24 Font (8char x 2Line)
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_oled_G_18x24(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos_x %= 128;
	pos_y %= 64;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(127 < pos){
			break;
		}
		disp_one_char_oled_G_18x24(pos, pos_y, *ucp);
		ucp++;
		pos += 18;
	}

}

// TVtHgQORQɊĝׂShbg̃f[^
const	unsigned char bt_07_20x32[8][4]={											// 5x7  20x32 ɑ傫鎞Ɏg
									{0b00001111, 0b00000000, 0b00000000, 0b00000000},	// D0
									{0b11110000, 0b00000000, 0b00000000, 0b00000000},	// D1
									{0b00000000, 0b00001111, 0b00000000, 0b00000000},	// D2
									{0b00000000, 0b11110000, 0b00000000, 0b00000000},	// D3
									{0b00000000, 0b00000000, 0b00001111, 0b00000000},	// D4
									{0b00000000, 0b00000000, 0b11110000, 0b00000000},	// D5
									{0b00000000, 0b00000000, 0b00000000, 0b00001111},	// D6
									{0b00000000, 0b00000000, 0b00000000, 0b11110000},	// D7
								};
//******************************
// Get Character Bit Data
// 20x32 Font
//  Get Data Save to c_data[4][24];
//******************************
static void	get_asc_data_20x32(unsigned char uc)
{
	unsigned short	us;
	unsigned char	ucd;
	unsigned char	i;
	unsigned char	j;
	unsigned char	k;
	unsigned char	bt;

	us = uc;
	us *= 5;

	for(i=0;i<24;i++){										// tHg鏊NA
		for(j=0;j<4;j++){
			c_data[j][i] = 0;
		}
	}

	for(i=0;i<5;i++){										// 5x7 tHg擾郋[v
		ucd = pgm_read_byte(&(font5x7[us + i]));
		for(bt=0x01,k=0;k<8;k++, bt<<= 1){					// 擾Wrbg̃f[^郋[v
			if((ucd & bt)!=0){
				for(j=0;j<4;j++){							// 5x7 ̂Prbg̃f[^4x4 ̃f[^ɂ郋[vi͂QỎj
					c_data[0][i*4+j] |= bt_07_20x32[k][0];
					c_data[1][i*4+j] |= bt_07_20x32[k][1];
					c_data[2][i*4+j] |= bt_07_20x32[k][2];
					c_data[3][i*4+j] |= bt_07_20x32[k][3];
				}
			}
		}
	}

}
//******************************
// display OLED One charcter 24x32 Font
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  uc : Charcter
//    E\sb`͂QShbgitHgԂShbgLj
// *****************************
void	disp_one_char_oled_G_24x32(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	i;
	unsigned char	j;
	unsigned char	x;

	pos_x %= 128;
	pos_y %= 64;
	pos_y /= 8;

	get_asc_data_20x32(uc);						// Get Character Bit Data

	for(i=0;i<4;i++){
		if(7 < (pos_y + i)){
			break;
		}
		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_CMD_MULTI);	// R}h𕡐

		twi_write(0xb0 | (pos_y+i));			// Page Set

		twi_write(0x10 | (pos_x >> 4));			// Column High Address Set
		twi_write(pos_x & 0x0f);				// Column Low Address Set

		twi_stop();								// TWI ~


		twi_start(SD1306_ADDR, TWI_WRITE);		// TWI Jn
		twi_write(SD1306_CONTROL_DATA_MULTI);	// f[^𕡐

		c_data[i][20] = 0x00;
		c_data[i][21] = 0x00;
		c_data[i][22] = 0x00;
		c_data[i][23] = 0x00;
		x = pos_x;
		for(j = 0;((j<24)&&(x<128)); j++,x++){
			twi_write(c_data[i][j]);
		}

		twi_stop();								// TWI ~

	}
}
//******************************
// display OLED 24x32 Font (4char x 1Line)
//  pos_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 63)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_oled_G_24x32(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos_x %= 128;
	pos_y %= 64;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(127 < pos){
			break;
		}
		disp_one_char_oled_G_24x32(pos, pos_y, *ucp);
		ucp++;
		pos += 24;
	}

}



// tHg`FbN\
//******************************
// display Font OLED(21char x 8Line)
//  Code 0 --> 160
// *****************************
void	disp_oled_G_font_check1(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	uc = 0;
	for(y=0;y<8;y++){
		for(x=0;x<21;x++){
			disp_one_char_oled_G(x*6, y*8, uc);
			uc++;
		}
	}
}

//******************************
// display Font OLED(21char x 6Line)
//  Code 161 --> 255
// *****************************
void	disp_oled_G_font_check2(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;
	unsigned char	owari = 0;

	uc = 161;
	for(y=0;y<5;y++){
		for(x=0;x<21;x++){
			disp_one_char_oled_G(x*6, y*8, uc);
			uc++;
			if(uc == 0){
				owari = 1;
				break;
			}
		}
		if(owari != 0){
			break;
		}
	}
}

//******************************
// display Font OLED(21char x 8Line ]\)
//  Code 0 --> 160
// *****************************
void	disp_oled_G_reverse_font_check1(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	uc = 0;
	for(y=0;y<8;y++){
		for(x=0;x<21;x++){
			disp_one_char_oled_G_reverse(x*6, y*8, uc);
			uc++;
		}
	}
}

//******************************
// display Font OLED(21char x 6Line ]\)
//  Code 161 --> 255
// *****************************
void	disp_oled_G_reverse_font_check2(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;
	unsigned char	owari = 0;

	uc = 161;
	for(y=0;y<5;y++){
		for(x=0;x<21;x++){
			disp_one_char_oled_G_reverse(x*6, y*8, uc);
			uc++;
			if(uc == 0){
				owari = 1;
				break;
			}
		}
		if(owari != 0){
			break;
		}
	}
}

