//*****************************************
// Photo Box with ATmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
// File Name:uart.c
//
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//  2023/12/09 Modify for Photo Box with ATmega2560 Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega2560_photo_box_h.h"

#include	"timer_h.h"
#include	"uart_h.h"

// **********************************************************
// ************************** UART **************************
// **********************************************************

#define			NofRxdBuf				64					// Mf[^obt@̑傫iQ̊KɌj
#define			DATA_WARITE_POS_MASK	(NofRxdBuf - 1)
unsigned char	rxd_data[NofRxdBuf];						// Mf[^obt@
unsigned char	write_rxd_pos = 0;
unsigned char	read_rxd_pos = 0;
unsigned short	gBPS_600 = BPS_600;

//***************************
// UART1 Initial
//***************************
void	uart1_init(void)
{
	delay_2us(100/2);											// POOr҂


	UBRR1H  = (unsigned char)((gBPS_600>>8) & 0xff);			// aorigj
	UBRR1L  = (unsigned char)(gBPS_600 & 0xff);					// aorigj

	UCSR1C = (V_PARITY_NON | V_DATA_8);							// peBAf[^

	UCSR1A = V_UCSR1A;
	UCSR1B = V_UCSR1B;

}
//***************************
// UART1 Close
//***************************
void	uart1_close(void)
{
	UCSR1B = 0x00;
	delay_2us(100/2);											// POOr҂
}
//***************************
// UART1 Pause
//***************************
void	uart1_pause(void)
{
	UCSR1B &= ~V_UCSR1B_RXEN;
	delay_2us(100/2);								// POOr҂
}
//***************************
// UART1 Restart
//***************************
void	uart1_restart(void)
{
	UCSR1B |= V_UCSR1B_RXEN;
	delay_2us(100/2);								// POOr҂
}

//***************************
// UART1 TxD One Char
//  荞݂gȂ
//***************************
void	uart1_tx_one(unsigned char uc)
{
	while((UCSR1A & (1 << UDRE1)) == 0){
		;
	}
	UDR1 = uc;
}
//***************************
// UART1 TxD String
//  荞݂gȂ
//***************************
void	uart1_tx_str(char *str)
{
	while(*str != 0){
		uart1_tx_one((unsigned char)(*str));
		str++;
	}
}
//***************************
// UART1 TxD String + CR + LF
//***************************
void	uart1_tx_str_crlf(char *str)
{
	uart1_tx_str(str);											// UART TxD String
	uart1_tx_one(0x0d);											// CR
	uart1_tx_one(0x0a);											// LF
}

//***************************
// UART1 RXD Interrupt
//***************************
ISR	(USART1_RX_vect)
{
	unsigned char	er;
	unsigned char	uc;
	unsigned char	wr_pos;

	er = (UCSR1A & ((1<<FE1)|(1<<DOR1)|(1<<UPE1)) );	// G[Ԏ擾
	uc = UDR1;											// Mf[^擾

	if(er == 0){										// G[
		wr_pos = write_rxd_pos;
		rxd_data[wr_pos] = uc;							// Mf[^obt@Ɏ擾
		wr_pos++;
		wr_pos &= DATA_WARITE_POS_MASK;
		if(wr_pos != read_rxd_pos){						// ݈ʒuǂݏoʒuɒǂĂȂ
			write_rxd_pos = wr_pos;
		}
	}

}
//***************************
// RXD Read Call from Main
//   uc: Mf[^鏊
// ߂l  : 0=Mf[^
//         : 1=Mf[^L
//***************************
unsigned char	Get_rxd(unsigned char *uc)
{
	unsigned char	r=0;
	if(write_rxd_pos == read_rxd_pos){						// Mf[^
		;
	}else{
		r = 1;
		*uc = rxd_data[read_rxd_pos];						// Mf[^obt@擾
		read_rxd_pos++;
		read_rxd_pos &= DATA_WARITE_POS_MASK;
	}
	return(r);
}

